﻿using System;
using System.Collections.Generic;
using UnityEngine;
using System.Reflection;
using MonoMod.RuntimeDetour;
using Dungeonator;
using System.Collections;
using SGUI;

namespace noScaling
{

    public class ScalingModule : ETGModule
    {
        public static string ZipFilePath;
        public static string FilePath;
        public static ETGModuleMetadata metadata = new ETGModuleMetadata();

        public static readonly string MOD_NAME = "No Enemy Health Scaling";
        public static readonly string VERSION = "1.0.0";
        public static readonly string TEXT_COLOR = "#00FFFF";

        public override void Start()
        {
            try
            {
               
                ETGMod.StartGlobalCoroutine(DelayedStartCR());

                SGroup sGroup = new SGroup();
                sGroup.AutoGrowDirection = SGroup.EDirection.Vertical;
                sGroup.AutoLayout = (SGroup g) => g.AutoLayoutHorizontal;
                sGroup.OnUpdateStyle = delegate (SElement elem)
                {
                    elem.Fill();
                };
                sGroup.AutoLayoutVerticalStretch = false;
                sGroup.AutoLayoutHorizontalStretch = false;
                sGroup.GrowExtra = Vector2.zero;
                sGroup.ContentSize = Vector2.zero;
                sGroup.AutoLayoutPadding = 0;
                sGroup.Background = Color.clear;
                Texture2D tex = ItemAPI.ResourceExtractor.GetTextureFromResource("noHealthScaling/Resources/icon.png");
                TextureScale.Point(tex, Mathf.RoundToInt(tex.width * 0.3f), Mathf.RoundToInt(tex.height * 0.3f));

                SImage img = new SImage(tex);
                sGroup.Children.Add(img);
                ETGModConsole.Instance.GUI[0].Children.Add(sGroup);

                ETGModConsole.Instance.GUI[0].UpdateStyle();
                AdvancedLogging.Log($"{MOD_NAME} v{VERSION} started successfully.", new Color32(23, 235, 196, 255));
                
            }
            catch (Exception e)
            {
                AdvancedLogging.LogPlain(e, Color.red);
            }
        }

        public IEnumerator DelayedStartCR()
        {
            yield return null;
            DelayedStart();
            yield break;
        }

        public void DelayedStart()
        {
                for (int i = 0; i<GameManager.Instance.dungeonFloors.Count; i++)
                {
                    GameManager.Instance.GetLevelDefinitionFromName(GameManager.Instance.dungeonFloors[i].dungeonSceneName).enemyHealthMultiplier = 1;
                }
                for (int j = 0; j<GameManager.Instance.customFloors.Count; j++)
                {
                    GameManager.Instance.GetLevelDefinitionFromName(GameManager.Instance.customFloors[j].dungeonSceneName).enemyHealthMultiplier = 1;
                }
        }

    public static void Log(string text, string color = "#FFFFFF")
        {
            ETGModConsole.Log($"<color={color}>{text}</color>");
        }
        public override void Exit() { }
        public override void Init() { }
		
	}

}
